## cvc4 1.8

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

#-----------------------------------------------------------------------------#
# Project configuration

project(cvc4)

set(CVC4_MAJOR   1) # Major component of the version of CVC4.
set(CVC4_MINOR   8) # Minor component of the version of CVC4.
set(CVC4_RELEASE 0) # Release component of the version of CVC4.

# Extraversion component of the version of CVC4.
set(CVC4_EXTRAVERSION "")

# Shared library versioning. Increment SOVERSION for every new CVC4 release.
set(CVC4_SOVERSION 7)

# Full release string for CVC4.
if(CVC4_RELEASE)
  set(CVC4_RELEASE_STRING
      "${CVC4_MAJOR}.${CVC4_MINOR}.${CVC4_RELEASE}${CVC4_EXTRAVERSION}")
else()
  set(CVC4_RELEASE_STRING "${CVC4_MAJOR}.${CVC4_MINOR}${CVC4_EXTRAVERSION}")
endif()

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)

# Generate compile_commands.json, which can be used for various code completion
# plugins.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#-----------------------------------------------------------------------------#
# Policies

# Required for FindGLPK since it sets CMAKE_REQUIRED_LIBRARIES
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

#-----------------------------------------------------------------------------#
# Tell CMake where to find our dependencies

if(ABC_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${ABC_DIR}")
endif()
if(ANTLR_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${ANTLR_DIR}")
endif()
if(CADICAL_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${CADICAL_DIR}")
endif()
if(CRYPTOMINISAT_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${CRYPTOMINISAT_DIR}")
endif()
if(CXXTEST_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${CXXTEST_DIR}")
endif()
if(DRAT2ER_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${DRAT2ER_DIR}")
endif()
if(GLPK_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${GLPK_DIR}")
endif()
if(GMP_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${GMP_DIR}")
endif()
if(KISSAT_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${KISSAT_DIR}")
endif()
if(LFSC_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${LFSC_DIR}")
endif()
if(SYMFPU_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${SYMFPU_DIR}")
endif()

# By default the contrib/get-* scripts install dependencies to deps/install.
list(APPEND CMAKE_PREFIX_PATH "${PROJECT_SOURCE_DIR}/deps/install")

#-----------------------------------------------------------------------------#

set(INCLUDE_INSTALL_DIR include)
set(LIBRARY_INSTALL_DIR lib)
set(RUNTIME_INSTALL_DIR bin)

#-----------------------------------------------------------------------------#

include(Helpers)

#-----------------------------------------------------------------------------#
# User options

# License
option(ENABLE_GPL "Enable GPL dependencies")

# General build options
#
# >> 3-valued: IGNORE ON OFF
#    > allows to detect if set by user (default: IGNORE)
#    > only necessary for options set for build types
cvc4_option(ENABLE_ASAN           "Enable ASAN build")
cvc4_option(ENABLE_UBSAN          "Enable UBSan build")
cvc4_option(ENABLE_TSAN           "Enable TSan build")
cvc4_option(ENABLE_ASSERTIONS     "Enable assertions")
cvc4_option(ENABLE_COMP_INC_TRACK
            "Enable optimizations for incremental SMT-COMP tracks")
cvc4_option(ENABLE_DEBUG_SYMBOLS  "Enable debug symbols")
cvc4_option(ENABLE_DUMPING        "Enable dumping")
cvc4_option(ENABLE_MUZZLE         "Suppress ALL non-result output")
cvc4_option(ENABLE_PROOFS         "Enable proof support")
cvc4_option(ENABLE_STATISTICS     "Enable statistics")
cvc4_option(ENABLE_TRACING        "Enable tracing")
cvc4_option(ENABLE_UNIT_TESTING   "Enable unit testing")
cvc4_option(ENABLE_VALGRIND       "Enable valgrind instrumentation")
cvc4_option(ENABLE_SHARED         "Build as shared library")
cvc4_option(ENABLE_STATIC_BINARY
            "Build static binaries with statically linked system libraries")
# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(ENABLE_BEST             "Enable dependencies known to give best performance")
option(ENABLE_COVERAGE         "Enable support for gcov coverage testing")
option(ENABLE_DEBUG_CONTEXT_MM "Enable the debug context memory manager")
option(ENABLE_PROFILING        "Enable support for gprof profiling")

# Optional dependencies
#
# >> 3-valued: IGNORE ON OFF
#    > allows to detect if set by user (default: IGNORE)
#    > only necessary for options set for ENABLE_BEST
cvc4_option(USE_ABC           "Use ABC for AIG bit-blasting")
cvc4_option(USE_CADICAL       "Use CaDiCaL SAT solver")
cvc4_option(USE_CLN           "Use CLN instead of GMP")
cvc4_option(USE_CRYPTOMINISAT "Use CryptoMiniSat SAT solver")
cvc4_option(USE_GLPK          "Use GLPK simplex solver")
cvc4_option(USE_KISSAT        "Use Kissat SAT solver")
cvc4_option(USE_READLINE      "Use readline for better interactive support")
# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(USE_DRAT2ER            "Include drat2er for making eager BV proofs")
option(USE_LFSC               "Use LFSC proof checker")
option(USE_SYMFPU             "Use SymFPU for floating point support")
option(USE_PYTHON2            "Prefer using Python 2 (for Python bindings)")
option(USE_PYTHON3            "Prefer using Python 3 (for Python bindings)")

# Custom install directories for dependencies
# If no directory is provided by the user, we first check if the dependency was
# installed via the corresponding contrib/get-* script and if not found, we
# check the intalled system version. If the user provides a directory we
# immediately fail if the dependency was not found at the specified location.
set(ABC_DIR           "" CACHE STRING "Set ABC install directory")
set(ANTLR_DIR         "" CACHE STRING "Set ANTLR3 install directory")
set(CADICAL_DIR       "" CACHE STRING "Set CaDiCaL install directory")
set(CRYPTOMINISAT_DIR "" CACHE STRING "Set CryptoMiniSat install directory")
set(CXXTEST_DIR       "" CACHE STRING "Set CxxTest install directory")
set(DRAT2ER_DIR       "" CACHE STRING "Set drat2er install directory")
set(GLPK_DIR          "" CACHE STRING "Set GLPK install directory")
set(GMP_DIR           "" CACHE STRING "Set GMP install directory")
set(KISSAT_DIR        "" CACHE STRING "Set Kissat install directory")
set(LFSC_DIR          "" CACHE STRING "Set LFSC install directory")
set(SYMFPU_DIR        "" CACHE STRING "Set SymFPU install directory")

# Prepend binaries with prefix on make install
set(PROGRAM_PREFIX    "" CACHE STRING "Program prefix on make install")

# Supported SWIG language bindings
option(BUILD_SWIG_BINDINGS_JAVA   "Build Java bindings with SWIG")
option(BUILD_SWIG_BINDINGS_PYTHON "Build Python bindings with SWIG")

# Supprted language bindings based on new C++ API
option(BUILD_BINDINGS_PYTHON "Build Python bindings based on new C++ API ")

#-----------------------------------------------------------------------------#
# Internal cmake variables

set(OPTIMIZATION_LEVEL 3)
set(GPL_LIBS "")

#-----------------------------------------------------------------------------#
# Determine number of threads available, used to configure (default) parallel
# execution of custom test targets (can be overriden with ARGS=-jN).

include(ProcessorCount)
ProcessorCount(CTEST_NTHREADS)
if(CTEST_NTHREADS EQUAL 0)
  set(CTEST_NTHREADS 1)
endif()

#-----------------------------------------------------------------------------#
# Build types

# Note: Module CodeCoverage requires the name of the debug build to conform
#       to cmake standards (first letter uppercase).
set(BUILD_TYPES Production Debug Testing Competition)

if(ENABLE_ASAN OR ENABLE_UBSAN OR ENABLE_TSAN)
  set(CMAKE_BUILD_TYPE Debug)
endif()

# Set the default build type to Production
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Production CACHE STRING "Options are: ${BUILD_TYPES}" FORCE)
  # Provide drop down menu options in cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${BUILD_TYPES})
endif()

# Check if specified build type is valid.
list(FIND BUILD_TYPES ${CMAKE_BUILD_TYPE} FOUND_BUILD_TYPE)
if(${FOUND_BUILD_TYPE} EQUAL -1)
  message(FATAL_ERROR
    "'${CMAKE_BUILD_TYPE}' is not a valid build type. "
    "Available builds are: ${BUILD_TYPES}")
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE} build")
include(Config${CMAKE_BUILD_TYPE})

#-----------------------------------------------------------------------------#
# Compiler flags

add_check_c_cxx_flag("-O${OPTIMIZATION_LEVEL}")
add_check_c_cxx_flag("-Wall")
add_check_c_flag("-fexceptions")
add_check_c_cxx_flag("-Wno-deprecated")
add_check_cxx_flag("-Wsuggest-override")
add_check_cxx_flag("-Wnon-virtual-dtor")
add_check_c_cxx_flag("-Wimplicit-fallthrough")
add_check_c_cxx_flag("-Wshadow")

# Temporarily disable -Wclass-memaccess to suppress 'no trivial copy-assignment'
# cdlist.h warnings. Remove when fixed.
add_check_cxx_flag("-Wno-class-memaccess")

if (WIN32)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--stack,100000000")
endif ()

#-----------------------------------------------------------------------------#
# Use ld.gold if available

execute_process(COMMAND ${CMAKE_C_COMPILER}
                -fuse-ld=gold
                -Wl,--version ERROR_QUIET OUTPUT_VARIABLE LD_VERSION)
if ("${LD_VERSION}" MATCHES "GNU gold")
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -fuse-ld=gold")
  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -fuse-ld=gold")
  string(APPEND CMAKE_MODULE_LINKER_FLAGS " -fuse-ld=gold")
  message(STATUS "Using GNU gold linker.")
endif ()

#-----------------------------------------------------------------------------#
# Option defaults (three-valued options (cvc4_option(...)))
#
# These options are only set if their value is IGNORE. Otherwise, the user
# already set the option, which we don't want to overwrite.

if(ENABLE_STATIC_BINARY)
  cvc4_set_option(ENABLE_SHARED OFF)
else()
  cvc4_set_option(ENABLE_SHARED ON)
endif()

#-----------------------------------------------------------------------------#
# Set options for best configuration

if(ENABLE_BEST)
  cvc4_set_option(USE_ABC ON)
  cvc4_set_option(USE_CADICAL ON)
  cvc4_set_option(USE_CLN ON)
  cvc4_set_option(USE_CRYPTOMINISAT ON)
  cvc4_set_option(USE_GLPK ON)
  cvc4_set_option(USE_READLINE ON)
endif()

# Only enable unit testing if assertions are enabled. Otherwise, unit tests
# that expect AssertionException to be thrown will fail.
if(NOT ENABLE_ASSERTIONS)
  set(ENABLE_UNIT_TESTING OFF)
endif()

#-----------------------------------------------------------------------------#
# Shared/static libraries
#
# This needs to be set before any find_package(...) command since we want to
# search for static libraries with suffix .a.

if(ENABLE_SHARED)
  set(BUILD_SHARED_LIBS ON)
  if(ENABLE_STATIC_BINARY)
    set(ENABLE_STATIC_BINARY OFF)
    message(WARNING "Disabling static binary since shared build is enabled.")
  endif()

  # Embed the installation prefix as an RPATH in the executable such that the
  # linker can find our libraries (such as libcvc4parser) when executing the
  # cvc4 binary. This is for example useful when installing CVC4 with a custom
  # prefix on macOS (e.g. when using homebrew in a non-standard directory). If
  # we do not set this option, then the linker will not be able to find the
  # required libraries when trying to run CVC4.
  #
  # More information on RPATH in CMake:
  # https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/RPATH-handling
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIBRARY_INSTALL_DIR}")
else()
  set(CMAKE_FIND_LIBRARY_SUFFIXES .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
  set(BUILD_SHARED_LIBS OFF)
  cvc4_set_option(ENABLE_STATIC_BINARY ON)

  # Never build unit tests as static binaries, otherwise we'll end up with
  # ~300MB per unit test.
  if(ENABLE_UNIT_TESTING)
    message(WARNING "Disabling unit tests since static build is enabled.")
    set(ENABLE_UNIT_TESTING OFF)
  endif()
endif()

=== doc/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
# Set variables required for the documentation *.in files

string(TIMESTAMP MAN_DATE "%Y-%m-%d")
set(VERSION CVC4_RELEASE_STRING)

#-----------------------------------------------------------------------------#
# Generate files

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/SmtEngine.3cvc_template.in
  ${CMAKE_CURRENT_BINARY_DIR}/SmtEngine.3cvc_template)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cvc4.1_template.in
  ${CMAKE_CURRENT_BINARY_DIR}/cvc4.1_template)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cvc4.5.in
  ${CMAKE_CURRENT_BINARY_DIR}/cvc4.5)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/libcvc4.3.in
  ${CMAKE_CURRENT_BINARY_DIR}/libcvc4.3)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/libcvc4parser.3.in
  ${CMAKE_CURRENT_BINARY_DIR}/libcvc4parser.3)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/options.3cvc_template.in
  ${CMAKE_CURRENT_BINARY_DIR}/options.3cvc_template)

#-----------------------------------------------------------------------------#
# Install man pages

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cvc4.1 DESTINATION share/man/man1)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cvc4.5 DESTINATION share/man/man5)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/libcvc4.3
        ${CMAKE_CURRENT_BINARY_DIR}/libcvc4parser.3
        ${CMAKE_CURRENT_BINARY_DIR}/options.3cvc
        ${CMAKE_CURRENT_BINARY_DIR}/SmtEngine.3cvc
        DESTINATION share/man/man3)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(cvc4-examples)

set(CMAKE_CXX_STANDARD 11)

enable_testing()

# Find CVC4 package. If CVC4 is not installed into the default system location
# use `cmake .. -DCMAKE_PREFIX_PATH=path/to/lib/cmake` to specify the location
# of CVC4Config.cmake.
find_package(CVC4)

# Some of the examples require boost. Enable these examples if boost is
# installed.
find_package(Boost 1.50.0)

set(EXAMPLES_BIN_DIR ${CMAKE_BINARY_DIR}/bin)

# Add example target and create test to run example with ctest.
#
# > name: The name of the example
# > src_files: The list of source files passed as string "src1 src2 ..."
#              (alternative: "src1;src2;...").  If empty, <name>.cpp is assumed.
# > output_dir: Determines the examples subdirectory and is empty (passed as
#               empty string) for the examples root directory (this)
# > ARGN: Any additional arguments passed to the macro are interpreted as
#         as arguments to the test executable.
macro(cvc4_add_example name src_files output_dir)
  # The build target is created without the path prefix (not supported),
  # e.g., for '<output_dir>/myexample.cpp'
  #   we create build target 'myexample'
  #   and build it with 'make myexample'.
  # As a consequence, all build target names must be globally unique.
  if("${src_files}" STREQUAL "")
    set(src_files_list ${name}.cpp)
  else()
    string(REPLACE " " ";" src_files_list "${src_files}")
  endif()

  add_executable(${name} ${src_files_list})
  target_link_libraries(${name} CVC4::cvc4 CVC4::cvc4parser)

  # The test target is prefixed with the path,
  # e.g., for '<output_dir>/myexample.cpp'
  #   we create test target '<output_dir>/myexample'
  #   and run it with 'ctest -R "<output_dir>/myexample"'.
  set(example_bin_dir ${EXAMPLES_BIN_DIR}/${output_dir})
  if("${output_dir}" STREQUAL "")
    set(example_test ${name})
  else()
    set(example_test ${output_dir}/${name})
  endif()
  set_target_properties(${name}
    PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${example_bin_dir})
  add_test(${example_test} ${example_bin_dir}/${name} ${ARGN})
endmacro()

cvc4_add_example(simple_vc_cxx "" "")
cvc4_add_example(simple_vc_quant_cxx "" "")
cvc4_add_example(translator "" ""
    # argument to binary (for testing)
    ${CMAKE_CURRENT_SOURCE_DIR}/translator-example-input.smt2)

add_subdirectory(api)
add_subdirectory(hashsmt)
add_subdirectory(nra-translate)
add_subdirectory(sets-translate)

if(TARGET CVC4::cvc4jar)
  find_package(Java REQUIRED)
  include(UseJava)

  get_target_property(CVC4_JAR CVC4::cvc4jar JAR_FILE)

  add_jar(SimpleVC SimpleVC.java INCLUDE_JARS "${CVC4_JAR}")

  add_test(
    NAME java/SimpleVC
    COMMAND
      ${Java_JAVA_EXECUTABLE}
        -cp "${CVC4_JAR}:${CMAKE_BINARY_DIR}/SimpleVC.jar"
        -Djava.library.path=${CVC4_JNI_PATH}
        SimpleVC
  )

  add_subdirectory(api/java)
endif()

if(CVC4_BINDINGS_PYTHON)
  # If legacy Python API has been built
  add_subdirectory(api/python)
endif()

=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
# Collect libcvc4 source files

libcvc4_add_sources(
  api/cvc4cpp.cpp
  api/cvc4cpp.h
  api/cvc4cppkind.h
  context/backtrackable.h
  context/cddense_set.h
  context/cdhashmap.h
  context/cdhashmap_forward.h
  context/cdhashset.h
  context/cdhashset_forward.h
  context/cdinsert_hashmap.h
  context/cdinsert_hashmap_forward.h
  context/cdlist.h
  context/cdlist_forward.h
  context/cdmaybe.h
  context/cdo.h
  context/cdqueue.h
  context/cdtrail_queue.h
  context/context.cpp
  context/context.h
  context/context_mm.cpp
  context/context_mm.h
  decision/decision_attributes.h
  decision/decision_engine.cpp
  decision/decision_engine.h
  decision/decision_strategy.h
  decision/justification_heuristic.cpp
  decision/justification_heuristic.h
  lib/clock_gettime.c
  lib/clock_gettime.h
  lib/ffs.c
  lib/ffs.h
  lib/replacements.h
  lib/strtok_r.c
  lib/strtok_r.h
  preprocessing/assertion_pipeline.cpp
  preprocessing/assertion_pipeline.h
  preprocessing/passes/ackermann.cpp
  preprocessing/passes/ackermann.h
  preprocessing/passes/apply_substs.cpp
  preprocessing/passes/apply_substs.h
  preprocessing/passes/bool_to_bv.cpp
  preprocessing/passes/bool_to_bv.h
  preprocessing/passes/bv_abstraction.cpp
  preprocessing/passes/bv_abstraction.h
  preprocessing/passes/bv_eager_atoms.cpp
  preprocessing/passes/bv_eager_atoms.h
  preprocessing/passes/bv_gauss.cpp
  preprocessing/passes/bv_gauss.h
  preprocessing/passes/bv_intro_pow2.cpp
  preprocessing/passes/bv_intro_pow2.h
  preprocessing/passes/bv_to_bool.cpp
  preprocessing/passes/bv_to_bool.h
  preprocessing/passes/bv_to_int.cpp
  preprocessing/passes/bv_to_int.h
  preprocessing/passes/extended_rewriter_pass.cpp
  preprocessing/passes/extended_rewriter_pass.h
  preprocessing/passes/global_negate.cpp
  preprocessing/passes/global_negate.h
  preprocessing/passes/ho_elim.cpp
  preprocessing/passes/ho_elim.h
  preprocessing/passes/int_to_bv.cpp
  preprocessing/passes/int_to_bv.h
  preprocessing/passes/ite_removal.cpp
  preprocessing/passes/ite_removal.h
  preprocessing/passes/ite_simp.cpp
  preprocessing/passes/ite_simp.h
  preprocessing/passes/miplib_trick.cpp
  preprocessing/passes/miplib_trick.h
  preprocessing/passes/nl_ext_purify.cpp
  preprocessing/passes/nl_ext_purify.h
  preprocessing/passes/non_clausal_simp.cpp
  preprocessing/passes/non_clausal_simp.h
  preprocessing/passes/pseudo_boolean_processor.cpp
  preprocessing/passes/pseudo_boolean_processor.h
  preprocessing/passes/quantifier_macros.cpp
  preprocessing/passes/quantifier_macros.h
  preprocessing/passes/quantifiers_preprocess.cpp
  preprocessing/passes/quantifiers_preprocess.h
  preprocessing/passes/real_to_int.cpp
  preprocessing/passes/real_to_int.h
  preprocessing/passes/rewrite.cpp
  preprocessing/passes/rewrite.h
  preprocessing/passes/sep_skolem_emp.cpp
  preprocessing/passes/sep_skolem_emp.h
  preprocessing/passes/sort_infer.cpp
  preprocessing/passes/sort_infer.h
  preprocessing/passes/static_learning.cpp
  preprocessing/passes/static_learning.h
  preprocessing/passes/sygus_inference.cpp
  preprocessing/passes/sygus_inference.h
  preprocessing/passes/synth_rew_rules.cpp
  preprocessing/passes/synth_rew_rules.h
  preprocessing/passes/theory_preprocess.cpp
  preprocessing/passes/theory_preprocess.h
  preprocessing/passes/unconstrained_simplifier.cpp
  preprocessing/passes/unconstrained_simplifier.h
  preprocessing/preprocessing_pass.cpp
  preprocessing/preprocessing_pass.h
  preprocessing/preprocessing_pass_context.cpp
  preprocessing/preprocessing_pass_context.h
  preprocessing/preprocessing_pass_registry.cpp
  preprocessing/preprocessing_pass_registry.h
  preprocessing/util/ite_utilities.cpp
  preprocessing/util/ite_utilities.h
  printer/ast/ast_printer.cpp
  printer/ast/ast_printer.h
  printer/cvc/cvc_printer.cpp
  printer/cvc/cvc_printer.h
  printer/dagification_visitor.cpp
  printer/dagification_visitor.h
  printer/printer.cpp
  printer/printer.h
  printer/smt2/smt2_printer.cpp
  printer/smt2/smt2_printer.h
  printer/sygus_print_callback.cpp
  printer/sygus_print_callback.h
  printer/tptp/tptp_printer.cpp
  printer/tptp/tptp_printer.h
  proof/arith_proof.cpp
  proof/arith_proof.h
  proof/arith_proof_recorder.cpp
  proof/arith_proof_recorder.h
  proof/array_proof.cpp
  proof/array_proof.h
  proof/bitvector_proof.cpp
  proof/bitvector_proof.h
  proof/clausal_bitvector_proof.cpp
  proof/clausal_bitvector_proof.h
  proof/clause_id.h
  proof/cnf_proof.cpp
  proof/cnf_proof.h
  proof/dimacs.cpp
  proof/dimacs.h
  proof/drat/drat_proof.cpp
  proof/drat/drat_proof.h
  proof/er/er_proof.cpp
  proof/er/er_proof.h
  proof/lemma_proof.cpp
  proof/lemma_proof.h
  proof/lfsc_proof_printer.cpp
  proof/lfsc_proof_printer.h
  proof/lrat/lrat_proof.cpp
  proof/lrat/lrat_proof.h
  proof/proof.h
  proof/proof_manager.cpp
  proof/proof_manager.h
  proof/proof_output_channel.cpp
  proof/proof_output_channel.h
  proof/proof_utils.cpp
  proof/proof_utils.h
  proof/resolution_bitvector_proof.cpp
  proof/resolution_bitvector_proof.h
  proof/sat_proof.h
  proof/sat_proof_implementation.h
  proof/simplify_boolean_node.cpp
  proof/simplify_boolean_node.h
  proof/skolemization_manager.cpp
  proof/skolemization_manager.h
  proof/theory_proof.cpp
  proof/theory_proof.h
  proof/uf_proof.cpp
  proof/uf_proof.h
  proof/unsat_core.cpp
  proof/unsat_core.h
  prop/bvminisat/bvminisat.cpp
  prop/bvminisat/bvminisat.h
  prop/bvminisat/core/Dimacs.h
  prop/bvminisat/core/Solver.cc
  prop/bvminisat/core/Solver.h
  prop/bvminisat/core/SolverTypes.h
  prop/bvminisat/mtl/Alg.h
  prop/bvminisat/mtl/Alloc.h
  prop/bvminisat/mtl/Heap.h
  prop/bvminisat/mtl/IntTypes.h
  prop/bvminisat/mtl/Map.h
  prop/bvminisat/mtl/Queue.h
  prop/bvminisat/mtl/Sort.h
  prop/bvminisat/mtl/Vec.h
  prop/bvminisat/mtl/XAlloc.h
  prop/bvminisat/simp/SimpSolver.cc
  prop/bvminisat/simp/SimpSolver.h
  prop/bvminisat/utils/Options.h
  prop/cadical.cpp
  prop/cadical.h
  prop/cnf_stream.cpp
  prop/cnf_stream.h
  prop/cryptominisat.cpp
  prop/cryptominisat.h
  prop/kissat.cpp
  prop/kissat.h
  prop/minisat/core/Dimacs.h
  prop/minisat/core/Solver.cc
  prop/minisat/core/Solver.h
  prop/minisat/core/SolverTypes.h
  prop/minisat/minisat.cpp
  prop/minisat/minisat.h
  prop/minisat/mtl/Alg.h
  prop/minisat/mtl/Alloc.h
  prop/minisat/mtl/Heap.h
  prop/minisat/mtl/IntTypes.h
  prop/minisat/mtl/Map.h
  prop/minisat/mtl/Queue.h
  prop/minisat/mtl/Sort.h
  prop/minisat/mtl/Vec.h
  prop/minisat/mtl/XAlloc.h
  prop/minisat/simp/SimpSolver.cc
  prop/minisat/simp/SimpSolver.h
  prop/minisat/utils/Options.h
  prop/prop_engine.cpp
  prop/prop_engine.h
  prop/registrar.h
  prop/sat_solver.h
  prop/sat_solver_factory.cpp
  prop/sat_solver_factory.h
  prop/bv_sat_solver_notify.h
  prop/sat_solver_types.cpp
  prop/sat_solver_types.h
  prop/theory_proxy.cpp
  prop/theory_proxy.h
  smt/command.cpp
  smt/command.h
  smt/command_list.cpp
  smt/command_list.h
  smt/defined_function.h
  smt/dump.cpp
  smt/dump.h
  smt/logic_exception.h
  smt/logic_request.cpp
  smt/logic_request.h
  smt/managed_ostreams.cpp
  smt/managed_ostreams.h
  smt/model.cpp
  smt/model.h
  smt/model_core_builder.cpp
  smt/model_core_builder.h
  smt/model_blocker.cpp
  smt/model_blocker.h
  smt/process_assertions.cpp
  smt/process_assertions.h
  smt/set_defaults.cpp
  smt/set_defaults.h
  smt/smt_engine.cpp
  smt/smt_engine.h
  smt/smt_engine_scope.cpp
  smt/smt_engine_scope.h
  smt/smt_engine_stats.cpp
  smt/smt_engine_stats.h
  smt/smt_statistics_registry.cpp
  smt/smt_statistics_registry.h
  smt/term_formula_removal.cpp
  smt/term_formula_removal.h
  smt/update_ostream.h
  smt_util/boolean_simplification.cpp
  smt_util/boolean_simplification.h
  smt_util/nary_builder.cpp
  smt_util/nary_builder.h
  theory/arith/approx_simplex.cpp
  theory/arith/approx_simplex.h
  theory/arith/arith_ite_utils.cpp
  theory/arith/arith_ite_utils.h
  theory/arith/arith_msum.cpp
  theory/arith/arith_msum.h
  theory/arith/arith_rewriter.cpp
  theory/arith/arith_rewriter.h
  theory/arith/arith_static_learner.cpp
  theory/arith/arith_static_learner.h
  theory/arith/arith_utilities.cpp
  theory/arith/arith_utilities.h
  theory/arith/arithvar.cpp
  theory/arith/arithvar.h
  theory/arith/attempt_solution_simplex.cpp
  theory/arith/attempt_solution_simplex.h
  theory/arith/bound_counts.h
  theory/arith/callbacks.cpp
  theory/arith/callbacks.h
  theory/arith/congruence_manager.cpp
  theory/arith/congruence_manager.h
  theory/arith/constraint.cpp
  theory/arith/constraint.h
  theory/arith/constraint_forward.h
  theory/arith/cut_log.cpp
  theory/arith/cut_log.h
  theory/arith/delta_rational.cpp
  theory/arith/delta_rational.h
  theory/arith/dio_solver.cpp
  theory/arith/dio_solver.h
  theory/arith/dual_simplex.cpp
  theory/arith/dual_simplex.h
  theory/arith/error_set.cpp
  theory/arith/error_set.h
  theory/arith/fc_simplex.cpp
  theory/arith/fc_simplex.h
  theory/arith/infer_bounds.cpp
  theory/arith/infer_bounds.h
  theory/arith/linear_equality.cpp
  theory/arith/linear_equality.h
  theory/arith/matrix.cpp
  theory/arith/matrix.h
  theory/arith/nl/nl_constraint.cpp
  theory/arith/nl/nl_constraint.h
  theory/arith/nl/nl_lemma_utils.cpp
  theory/arith/nl/nl_lemma_utils.h
  theory/arith/nl/nl_model.cpp
  theory/arith/nl/nl_model.h
  theory/arith/nl/nl_monomial.cpp
  theory/arith/nl/nl_monomial.h
  theory/arith/nl/nl_solver.cpp
  theory/arith/nl/nl_solver.h
  theory/arith/nl/nonlinear_extension.cpp
  theory/arith/nl/nonlinear_extension.h
  theory/arith/nl/transcendental_solver.cpp
  theory/arith/nl/transcendental_solver.h
  theory/arith/normal_form.cpp
  theory/arith/normal_form.h
  theory/arith/partial_model.cpp
  theory/arith/partial_model.h
  theory/arith/simplex.cpp
  theory/arith/simplex.h
  theory/arith/simplex_update.cpp
  theory/arith/simplex_update.h
  theory/arith/soi_simplex.cpp
  theory/arith/soi_simplex.h
  theory/arith/tableau.cpp
  theory/arith/tableau.h
  theory/arith/tableau_sizes.cpp
  theory/arith/tableau_sizes.h
  theory/arith/theory_arith.cpp
  theory/arith/theory_arith.h
  theory/arith/theory_arith_private.cpp
  theory/arith/theory_arith_private.h
  theory/arith/theory_arith_private_forward.h
  theory/arith/theory_arith_type_rules.h
  theory/arith/type_enumerator.h
  theory/arrays/array_info.cpp
  theory/arrays/array_info.h
  theory/arrays/array_proof_reconstruction.cpp
  theory/arrays/array_proof_reconstruction.h
  theory/arrays/static_fact_manager.cpp
  theory/arrays/static_fact_manager.h
  theory/arrays/theory_arrays.cpp
  theory/arrays/theory_arrays.h
  theory/arrays/theory_arrays_rewriter.cpp
  theory/arrays/theory_arrays_rewriter.h
  theory/arrays/theory_arrays_type_rules.h
  theory/arrays/type_enumerator.h
  theory/arrays/union_find.cpp
  theory/arrays/union_find.h
  theory/assertion.cpp
  theory/assertion.h
  theory/atom_requests.cpp
  theory/atom_requests.h
  theory/booleans/circuit_propagator.cpp
  theory/booleans/circuit_propagator.h
  theory/booleans/proof_checker.cpp
  theory/booleans/proof_checker.h
  theory/booleans/theory_bool.cpp
  theory/booleans/theory_bool.h
  theory/booleans/theory_bool_rewriter.cpp
  theory/booleans/theory_bool_rewriter.h
  theory/booleans/theory_bool_type_rules.h
  theory/booleans/type_enumerator.h
  theory/builtin/theory_builtin.cpp
  theory/builtin/theory_builtin.h
  theory/builtin/theory_builtin_rewriter.cpp
  theory/builtin/theory_builtin_rewriter.h
  theory/builtin/theory_builtin_type_rules.h
  theory/builtin/proof_checker.cpp
  theory/builtin/proof_checker.h
  theory/builtin/type_enumerator.cpp
  theory/builtin/type_enumerator.h
  theory/bv/abstraction.cpp
  theory/bv/abstraction.h
  theory/bv/bitblast/aig_bitblaster.cpp
  theory/bv/bitblast/aig_bitblaster.h
  theory/bv/bitblast/bitblast_strategies_template.h
  theory/bv/bitblast/bitblast_utils.h
  theory/bv/bitblast/bitblaster.h
  theory/bv/bitblast/eager_bitblaster.cpp
  theory/bv/bitblast/eager_bitblaster.h

=== test/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
# Add target 'check', builds and runs
# > unit tests
# > regression tests of levels 0 and 1
# > system tests

add_custom_target(build-tests)

# Note: Do not add custom targets for running tests (regress, systemtests,
# units) as dependencies to other run targets. This will result in executing
# tests multiple times. For example, if check would depend on regress it would
# first run the command of the regress target (i.e., run all regression tests)
# and afterwards run the command specified for the check target.
# Dependencies of check are added in the corresponding subdirectories.
add_custom_target(check
  COMMAND
    ctest --output-on-failure -LE "regress[3-4]" -j${CTEST_NTHREADS} $$ARGS
  DEPENDS
    build-tests)

#-----------------------------------------------------------------------------#
# Add subdirectories

add_subdirectory(regress)
add_subdirectory(system EXCLUDE_FROM_ALL)

if(ENABLE_UNIT_TESTING)
  add_subdirectory(unit EXCLUDE_FROM_ALL)

  if(BUILD_SWIG_BINDINGS_JAVA)
    add_subdirectory(java)
  endif()
endif()

=== examples/api/CMakeLists.txt ===
set(CVC4_EXAMPLES_API
  bitvectors
  bitvectors-new
  bitvectors_and_arrays
  bitvectors_and_arrays-new
  combination
  combination-new
  datatypes
  datatypes-new
  extract
  extract-new
  helloworld
  helloworld-new
  linear_arith
  linear_arith-new
  sets
  sets-new
  strings
  strings-new
  sygus-fun
  sygus-grammar
  sygus-inv
)

foreach(example ${CVC4_EXAMPLES_API})
  cvc4_add_example(${example} "" "api")
endforeach()

=== examples/hashsmt/CMakeLists.txt ===
if(Boost_FOUND)
   cvc4_add_example(sha1_inversion
     "sha1_inversion.cpp word.cpp" "hashsmt"
     # arguments to binary (for testing)
     "a" "sha1_inversion.outfile")
endif()

cvc4_add_example(sha1_collision
  "sha1_collision.cpp word.cpp" "hashsmt"
  # arguments to binary (for testing)
  "1" "1" "sha1_collision.outfile")

=== examples/nra-translate/CMakeLists.txt ===
set(EXAMPLES_NRA_TRANSLATE_BIN_DIR ${EXAMPLES_BIN_DIR}/nra-translate)

set(CVC4_EXAMPLES_NRA_TRANSLATE
  normalize
  smt2info
  smt2todreal
  smt2toisat
  smt2tomathematica
  smt2toqepcad
  smt2toredlog
)

foreach(example ${CVC4_EXAMPLES_NRA_TRANSLATE})
  cvc4_add_example(${example} "" "nra-translate"
    # arguments to binary (for testing)
    # input file is required by all tests
    ${CMAKE_CURRENT_SOURCE_DIR}/nra-translate-example-input.smt2
    # This is a dummy argument for smt2toredlog (argument is only printed, can
    # be anything for testing purposes). We pass this to all examples since the
    # other examples ignore additional arguments.
    "foo")
endforeach()

=== examples/sets-translate/CMakeLists.txt ===
if(Boost_FOUND)
  cvc4_add_example(sets2arrays
    "sets_translate.cpp" "sets-translate"
    # argument to binary (for testing)
    ${CMAKE_CURRENT_SOURCE_DIR}/sets-translate-example-input.smt2)

  cvc4_add_example(sets2axioms
    "sets_translate.cpp" "sets-translate"
    # argument to binary (for testing)
    ${CMAKE_CURRENT_SOURCE_DIR}/sets-translate-example-input.smt2)
  target_compile_definitions(sets2axioms PRIVATE -DENABLE_AXIOMS)
endif()

=== proofs/signatures/CMakeLists.txt ===
# These CORE_PLFs are combined to give a "master signature" against which
# proofs are checked internally when using --check-proofs. To add support for
# more theories, just list them here in the same order you would to the LFSC
# proof-checker binary.

set(core_signature_files
    sat.plf
    er.plf
    smt.plf
    th_base.plf
    lrat.plf
    drat.plf
    th_arrays.plf
    th_bv.plf
    th_bv_bitblast.plf
    th_bv_rewrites.plf
    th_real.plf
    th_int.plf
    th_lira.plf
)

set(CORE_SIGNATURES "")

foreach(f ${core_signature_files})
  file(READ ${f} tmp)
  set(CORE_SIGNATURES "${CORE_SIGNATURES}\n${tmp}")
endforeach(f)

string(REPLACE "\\" "\\\\" CORE_SIGNATURES "${CORE_SIGNATURES}")
string(REPLACE "\"" "\\\"" CORE_SIGNATURES "${CORE_SIGNATURES}")
string(REPLACE "\n" "\\n\\\n" CORE_SIGNATURES "${CORE_SIGNATURES}")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/signatures.cpp.in
  ${CMAKE_CURRENT_BINARY_DIR}/signatures.cpp)

libcvc4_add_sources(GENERATED signatures.cpp)
install(FILES ${core_signature_files} DESTINATION share/cvc4)

=== src/base/CMakeLists.txt ===
#-----------------------------------------------------------------------------#
# Extract info from Git for git_versioninfo.cpp
# Note: GitInfo.cmake generates git_versioninfo.cpp.

find_package(Git)
configure_file(GitInfo.cmake.in GitInfo.cmake @ONLY)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/git_versioninfo.cpp
  COMMAND ${CMAKE_COMMAND} -DGIT_FOUND=${GIT_FOUND} -P GitInfo.cmake
)
set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/git_versioninfo.cpp
  PROPERTIES GENERATED TRUE
)
add_custom_target(gen-gitinfo
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/git_versioninfo.cpp
)

#-----------------------------------------------------------------------------#

libcvc4_add_sources(
  check.cpp
  check.h
  configuration.cpp
  configuration.h
  configuration_private.h
  exception.cpp
  exception.h
  listener.cpp
  listener.h
  modal_exception.h
  output.cpp
  output.h
)

libcvc4_add_sources(GENERATED git_versioninfo.cpp)

#-----------------------------------------------------------------------------#
# Generate code for debug/trace tags

set(gentmptags_script ${CMAKE_CURRENT_LIST_DIR}/gentmptags.sh)
set(gentags_script ${CMAKE_CURRENT_LIST_DIR}/gentags.sh)
set(genheader_script ${CMAKE_CURRENT_LIST_DIR}/genheader.sh)

file(GLOB_RECURSE source_files
     ${PROJECT_SOURCE_DIR}/src/*.cpp
     ${PROJECT_SOURCE_DIR}/src/*.cc
     ${PROJECT_SOURCE_DIR}/src/*.h
     ${PROJECT_SOURCE_DIR}/src/*.g)
string(REPLACE ";" " " source_files_list "${source_files}")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags.tmp
  COMMAND
    ${gentmptags_script} ${CMAKE_CURRENT_LIST_DIR} Debug ${source_files_list}
  DEPENDS mktags ${gentmptags_script} ${source_files}
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.tmp
  COMMAND
    ${gentmptags_script} ${CMAKE_CURRENT_LIST_DIR} Trace ${source_files_list}
  DEPENDS mktags ${gentmptags_script} ${source_files}
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags
  COMMAND ${gentags_script} Debug
  DEPENDS ${gentags_script} ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags.tmp
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags
  COMMAND ${gentags_script} Trace
  DEPENDS ${gentags_script} ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.tmp
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags.h
  COMMAND ${genheader_script} ${CMAKE_CURRENT_LIST_DIR} Debug
  DEPENDS mktagheaders ${genheader_script} ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  COMMAND ${genheader_script} ${CMAKE_CURRENT_LIST_DIR} Trace
  DEPENDS mktagheaders ${genheader_script} ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags
)

add_custom_target(gen-tags
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags.h
    ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
)

set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/Debug_tags.h
  ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  PROPERTIES GENERATED TRUE
)

=== src/expr/CMakeLists.txt ===
libcvc4_add_sources(
  array.h
  array_store_all.cpp
  array_store_all.h
  ascription_type.h
  attribute.h
  attribute.cpp
  attribute_internals.h
  attribute_unique_id.h
  emptyset.cpp
  emptyset.h
  expr_iomanip.cpp
  expr_iomanip.h
  expr_manager_scope.h
  expr_sequence.cpp
  expr_sequence.h
  kind_map.h
  lazy_proof.cpp
  lazy_proof.h
  match_trie.cpp
  match_trie.h
  node.cpp
  node.h
  node_algorithm.cpp
  node_algorithm.h
  node_builder.h
  node_manager.cpp
  node_manager.h
  node_manager_attributes.h
  node_manager_listeners.cpp
  node_manager_listeners.h
  node_self_iterator.h
  node_trie.cpp
  node_trie.h
  node_traversal.cpp
  node_traversal.h
  node_value.cpp
  node_value.h
  sequence.cpp
  sequence.h
  node_visitor.h
  proof.cpp
  proof.h
  proof_checker.cpp
  proof_checker.h
  proof_generator.cpp
  proof_generator.h
  proof_node.cpp
  proof_node.h
  proof_node_algorithm.cpp
  proof_node_algorithm.h
  proof_node_to_sexpr.cpp
  proof_node_to_sexpr.h
  proof_node_manager.cpp
  proof_node_manager.h
  proof_rule.cpp
  proof_rule.h
  proof_step_buffer.cpp
  proof_step_buffer.h
  skolem_manager.cpp
  skolem_manager.h
  symbol_table.cpp
  symbol_table.h
  term_canonize.cpp
  term_canonize.h
  term_conversion_proof_generator.cpp
  term_conversion_proof_generator.h
  type.cpp
  type.h
  type_checker.h
  type_matcher.cpp
  type_matcher.h
  type_node.cpp
  type_node.h
  variable_type_map.h
  datatype.h
  datatype.cpp
  dtype.h
  dtype.cpp
  dtype_cons.h
  dtype_cons.cpp
  dtype_selector.h
  dtype_selector.cpp
  record.cpp
  record.h
  sequence.cpp
  sequence.h
  sygus_datatype.cpp
  sygus_datatype.h
  uninterpreted_constant.cpp
  uninterpreted_constant.h
)

libcvc4_add_sources(GENERATED
  kind.cpp
  kind.h
  metakind.cpp
  metakind.h
  expr.cpp
  expr.h
  expr_manager.cpp
  expr_manager.h
  type_checker.cpp
  type_properties.h
)

#
# Generate code for kinds.
#

set(mkkind_script ${CMAKE_CURRENT_LIST_DIR}/mkkind)
set(mkmetakind_script ${CMAKE_CURRENT_LIST_DIR}/mkmetakind)
set(mkexpr_script ${CMAKE_CURRENT_LIST_DIR}/mkexpr)

add_custom_command(
  OUTPUT kind.h
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/kind_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/kind.h
  DEPENDS mkkind kind_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT kind.cpp
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/kind_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/kind.cpp
  DEPENDS mkkind kind_template.cpp kind.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT type_properties.h
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/type_properties_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/type_properties.h
  DEPENDS mkkind type_properties_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT metakind.h
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/metakind_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/metakind.h
  DEPENDS mkmetakind metakind_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT metakind.cpp
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/metakind_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/metakind.cpp
  DEPENDS mkmetakind metakind_template.cpp metakind.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT expr.h
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/expr_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/expr.h
  DEPENDS mkexpr expr_template.h kind.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT expr.cpp
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/expr_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/expr.cpp
  DEPENDS mkexpr expr_template.cpp expr.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT expr_manager.h
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/expr_manager_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/expr_manager.h
  DEPENDS mkexpr expr_manager_template.h expr.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT expr_manager.cpp
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/expr_manager_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/expr_manager.cpp
  DEPENDS mkexpr expr_manager_template.cpp expr_manager.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT type_checker.cpp
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/type_checker_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/type_checker.cpp
  DEPENDS mkexpr type_checker_template.cpp ${KINDS_FILES}
)

add_custom_target(gen-expr
  DEPENDS
    kind.cpp
    kind.h
    metakind.cpp
    metakind.h
    expr.cpp
    expr.h
    expr_manager.cpp
    expr_manager.h
    type_checker.cpp
    type_properties.h
)

=== debian/changelog ===
cvc4 (1.8-5) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Fix FTBFS with CMake 4. Closes: #1112823.

  [ Santiago Vila ]
  * Drop "Priority: optional" (default).
  * Update standards-version.
  * Add debian/salsa.yml.

 -- Santiago Vila <sanvila@debian.org>  Mon, 27 Oct 2025 10:10:00 +0100

cvc4 (1.8-4) unstable; urgency=medium

  * Team upload.
  * Patch-out usage of python3-toml
  * Fix Team email address

 -- Alexandre Detiste <tchet@debian.org>  Sun, 27 Jul 2025 16:05:53 +0200

cvc4 (1.8-3) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with bash 5.2 (Closes: #1020010)
  * Fix FTBFS due to cryptominisat API changes by disabling cryptominisat

 -- Scott Talbert <swt@techie.net>  Sat, 29 Oct 2022 14:49:40 -0400

cvc4 (1.8-2) unstable; urgency=medium

  * Source-only reupload after the package has been through NEW.
  * Add patch 06-disable-tests.patch to disable several failing test
    cases that prevent the package from building on all release
    architectures it has previously been built on (see #970511).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Thu, 17 Sep 2020 18:29:09 +0200

cvc4 (1.8-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file.
  * Upgrade to debhelper compat level 13.
  * Upgrade to Standards-Version 4.5.0.
  * Update Homepage field in debian/control.
  * Update debian/copyright.
  * Update patches:
     - Rename 01-timestamps.patch into 00-timestamps.patch.
     - Drop 02-man-pages.patch (no longer needed; all man pages get
       installed now).
     - Drop 03-examples.patch (fixed upstream).
     - Drop 04-fix-spelling.patch (fixed upstream).
     - Add 01-disable-tests.patch to disable some lengthy test cases
       that would otherwise be run during the package build.
     - Add 02-install-lib-dir.patch to fix the directory into which
       the shared libraries are installed.
     - Add 03-remove-build-path.patch to help make the build more
       reproducible.
     - Add 04-spelling-errors.patch to fix the spelling errors found
       by Lintian.
     - Add 05-fix-headers.patch to make sure the installed header
       files are actually usable.
  * Switch to CMake build system.
  * Change build architectures to "any" (Closes: #941431).
  * Add print-version and simple-arith autopkgtests.
  * Adjust package names to new SONAME.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 13 Sep 2020 14:04:56 +0200

=== debian/control ===
Source: cvc4
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Fabian Wolff <fabi.wolff@arcor.de>
Section: math
Build-Depends: debhelper-compat (= 13),
               libgmp-dev, libcln-dev,
               antlr3, libantlr3c-dev,
               libboost-thread-dev,
               libreadline-dev,
               pkgconf,
               cxxtest,
               python3,
               cmake
Standards-Version: 4.7.2
Homepage: https://cvc4.github.io/
Vcs-Git: https://salsa.debian.org/science-team/cvc4.git
Vcs-Browser: https://salsa.debian.org/science-team/cvc4

Package: cvc4
Architecture: any
Depends: libcvc4-7 (= ${binary:Version}),
         libcvc4parser7 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: automated theorem prover for SMT problems
 CVC4 is an efficient automatic theorem prover for satisfiability
 modulo theories (SMT) problems. It can be used to prove the validity
 (or, dually, the satisfiability) of first-order formulas in a large
 number of built-in logical theories and their combination.
 .
 CVC4 is intended to be an open and extensible SMT engine, and it can
 be used as a stand-alone tool or as a library. It is the fourth in
 the Cooperating Validity Checker family of tools (also including CVC,
 CVC Lite and CVC3). CVC4 has been designed to increase the
 performance and reduce the memory overhead of its predecessors.
 .
 This package contains binaries needed to use CVC4 as a stand-alone
 tool.

Package: libcvc4-dev
Architecture: any
Section: libdevel
Depends: libcvc4-7 (= ${binary:Version}),
         libcvc4parser7 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
         libgmp-dev
Description: automated theorem prover for SMT problems (development files)
 CVC4 is an efficient automatic theorem prover for satisfiability
 modulo theories (SMT) problems. It can be used to prove the validity
 (or, dually, the satisfiability) of first-order formulas in a large
 number of built-in logical theories and their combination.
 .
 CVC4 is intended to be an open and extensible SMT engine, and it can
 be used as a stand-alone tool or as a library. It is the fourth in
 the Cooperating Validity Checker family of tools (also including CVC,
 CVC Lite and CVC3). CVC4 has been designed to increase the
 performance and reduce the memory overhead of its predecessors.
 .
 This package contains development files for CVC4. Install it if you
 want to develop applications that use CVC4's API.

Package: libcvc4-7
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: automated theorem prover for SMT problems (runtime)
 CVC4 is an efficient automatic theorem prover for satisfiability
 modulo theories (SMT) problems. It can be used to prove the validity
 (or, dually, the satisfiability) of first-order formulas in a large
 number of built-in logical theories and their combination.
 .
 CVC4 is intended to be an open and extensible SMT engine, and it can
 be used as a stand-alone tool or as a library. It is the fourth in
 the Cooperating Validity Checker family of tools (also including CVC,
 CVC Lite and CVC3). CVC4 has been designed to increase the
 performance and reduce the memory overhead of its predecessors.
 .
 This package contains CVC4's runtime shared libraries.

Package: libcvc4parser7
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: automated theorem prover for SMT problems (parser runtime)
 CVC4 is an efficient automatic theorem prover for satisfiability
 modulo theories (SMT) problems. It can be used to prove the validity
 (or, dually, the satisfiability) of first-order formulas in a large
 number of built-in logical theories and their combination.
 .
 CVC4 is intended to be an open and extensible SMT engine, and it can
 be used as a stand-alone tool or as a library. It is the fourth in
 the Cooperating Validity Checker family of tools (also including CVC,
 CVC Lite and CVC3). CVC4 has been designed to increase the
 performance and reduce the memory overhead of its predecessors.
 .
 This package contains runtime shared libraries for CVC4's parser.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath

export DEB_CPPFLAGS_MAINT_APPEND = \
	-DDEB_BUILD_DATE="\"$(shell date -d @$(SOURCE_DATE_EPOCH) +%F)\"" \
	-DDEB_BUILD_TIME="\"$(shell date -d @$(SOURCE_DATE_EPOCH) +%T)\""

export DEB_BUILD_BASEDIR = $(shell pwd)
export CCACHE_BASEDIR = $(DEB_BUILD_BASEDIR)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --                                        \
		-DENABLE_GPL=ON -DENABLE_SHARED=ON                  \
		-DENABLE_DEBUG_SYMBOLS=ON -DENABLE_PROOFS=ON        \
		-DENABLE_STATISTICS=ON -DENABLE_DUMPING=ON          \
		-DENABLE_UNIT_TESTING=ON -DENABLE_BEST=ON           \
		-DUSE_READLINE=ON -DUSE_PYTHON3=ON                  \
		-DUSE_ABC=OFF -DUSE_CADICAL=OFF -DUSE_CLN=ON        \
		-DUSE_CRYPTOMINISAT=OFF -DUSE_KISSAT=OFF            \
		-DUSE_GLPK=OFF                                      \
		-DCMAKE_BUILD_TYPE=Production

override_dh_installdocs:
	dh_installdocs --all NEWS AUTHORS THANKS

=== debian/tests/control ===
Tests: hello-world print-version
Depends: @, build-essential
Restrictions: superficial

Tests: simple-arith
Depends: @

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(\d[\d\.]*)\.tar\.gz/cvc4-$1\.tar\.gz/ \
  https://github.com/CVC4/CVC4/tags .*/(\d[\d\.]*)\.tar\.gz
